poj 3255 Roadblocks【次短路】

题目:poj 3255 Roadblocks

题意:给出一个无向图,然后求1到n点的次短路

分析:两种做法,第一种,Astat+最短路求k短路的方法。

第二种是比较暴力的方法。

先求1点到所有点的最短路dis1

然后求n点到所有点的最短路dis2

然后枚举所有边,则次短路为dis1【from】 + dis2【to】 + w【i】中大于最短路的最短的。

AC代码:

#include <cstdio>
#include <string>
#include <cstring>
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
using namespace std;
const int N = 5700;
const int inf = 0x3f3f3f3f;
struct Node
{
    int to,val;
};
vector<Node> g[N],rg[N];
int dis[N];
bool vis[N];
int n,m;
void SPFA(int src)
{
    int i;
    memset(dis,inf,sizeof(dis));
    dis[src] = 0;
    queue<int> Q;
    Q.push(src);
    while(!Q.empty())
    {
        int u,v;
        u = Q.front();
        Q.pop();
        for(int i = 0;i<g[u].size();i++)
        {
            v = g[u][i].to;
            if(dis[v]>dis[u]+g[u][i].val) //记得这里这样写  最后改一下vis
            {
                dis[v] = dis[u] + g[u][i].val;
                Q.push(v);
            }
        }
    }
}
int dis1[N];
void SPFA1(int src)
{
    int i;
    memset(dis1,inf,sizeof(dis1));
    dis1[src] = 0;
    queue<int> Q;
    Q.push(src);
    while(!Q.empty())
    {
        int u,v;
        u = Q.front();
        Q.pop();
        for(int i = 0;i<g[u].size();i++)
        {
            v = g[u][i].to;
            if(dis1[v]>dis1[u]+g[u][i].val) //记得这里这样写  最后改一下vis
            {
                dis1[v] = dis1[u] + g[u][i].val;
                Q.push(v);
            }
        }
    }
}
void Clear(int x)
{
    for(int i=0;i<=x;i++){
        g[i].clear();
        rg[i].clear();
    }
}
int x[101000],y[101000],z[101000];
int main()
{
    //freopen("a.txt","r",stdin);
    while(~scanf("%d%d",&n,&m))
    {
        for(int i=0;i<m;i++)
        {
            scanf("%d%d%d",&x[i],&y[i],&z[i]);
            g[y[i]].push_back((Node){x[i],z[i]});
            g[x[i]].push_back((Node){y[i],z[i]});
            rg[x[i]].push_back((Node){y[i],z[i]});
            rg[y[i]].push_back((Node){x[i],z[i]});
        }
        int s=1,t=n,k=2;
        SPFA(t);
        SPFA1(s);
        int mi = dis1[t];
        int ans = inf;
        for(int i=0;i<m;i++)
        {
            int tmp = dis[y[i]] + dis1[x[i]] + z[i];
            int css = dis[x[i]] + dis1[y[i]] + z[i];
            if(tmp>mi)
                ans = min(ans,tmp);
            if(css>mi)
                ans = min(ans,css);
        }
        printf("%d\n",ans);
        Clear(n);
    }
    return 0;
}
时间: 2024-08-21 18:34:45

poj 3255 Roadblocks【次短路】的相关文章

POJ 3255 Roadblocks (次短路问题)

解法有很多奇葩的地方,比如可以到达终点再跳回去再跳回来(比如有两个点)....反正就是不能有最短路,不过没关系,算法都能给出正确结果 思想:和求最短路上的点套路一样,spfa先正着求一次,再反着求一次最短路,然后枚举每条边<i,j>找dist_zheng[i] + len<i,j> + dist_fan[j]的第二小值即可!注意不能用邻接矩阵,那样会MLE,应该用邻接表 /* poj 3255 3808K 266MS */ #include<cstdio> #inclu

POJ - 3255 Roadblocks (次短路)

POJ - 3255 Roadblocks Time Limit: 2000MS Memory Limit: 65536KB 64bit IO Format: %I64d & %I64u Submit Status Description Bessie has moved to a small farm and sometimes enjoys returning to visit one of her best friends. She does not want to get to her

POJ 3255 Roadblocks (次短路模板)

Roadblocks http://poj.org/problem?id=3255 Time Limit: 2000MS   Memory Limit: 65536K       Description Bessie has moved to a small farm and sometimes enjoys returning to visit one of her best friends. She does not want to get to her old home too quick

POJ 3255 Roadblocks

Roadblocks Time Limit: 2000ms Memory Limit: 65536KB This problem will be judged on PKU. Original ID: 325564-bit integer IO format: %lld      Java class name: Main Bessie has moved to a small farm and sometimes enjoys returning to visit one of her bes

poj - 3225 Roadblocks(次短路)

http://poj.org/problem?id=3255 bessie 有时会去拜访她的朋友,但是她不想走最快回家的那条路,而是想走一条比最短的路长的次短路. 城镇由R条双向路组成,有N个路口.标号为1到N,问1号路口到N号路口的次短路长度是多少?次短路是 比最短路长度长的次短的路径.同一条边可以经过多次. 到某个顶点v的次短路要么帅到其他顶点u的最短路在加上u-v的边,要么是到u的次短路再加上u-v的边, 因此所需要求的就是到所有顶点的最短路和次短路,因此,对于每个顶点,我们记录的不仅仅是

POJ 3255 Roadblocks (次短路径 + Dijkstra算法)

Roadblocks Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 7982   Accepted: 2921 Description Bessie has moved to a small farm and sometimes enjoys returning to visit one of her best friends. She does not want to get to her old home too q

POJ 3255 Roadblocks (Dijkstra求最短路径的变形)(Dijkstra求次短路径)

Roadblocks Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 16425   Accepted: 5797 Description Bessie has moved to a small farm and sometimes enjoys returning to visit one of her best friends. She does not want to get to her old home too

POJ 3255 Roadblocks Dijkstra 算法变形

#include <cstdio> #include <iostream> #include <queue> using namespace std; const int INF = 1000000; const int maxn = 5005; struct edge{ int y,w; edge(int cy,int ww){ y = cy; w = ww; } }; vector<edge> vec[maxn]; int n,m; struct num

POJ 3255 &amp;&amp; HDU 1688 &amp;&amp; HDU 3191 次短路问题

POJ 3255 Roadblocks Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 7627   Accepted: 2798 Description Bessie has moved to a small farm and sometimes enjoys returning to visit one of her best friends. She does not want to get to her old h